main {
  height: 100%;
  position: relative;
  display: flex;
}

.side-panel {
  display: flex;
  flex-direction: row;
  height: 100%;
  box-sizing: border-box;
  // position: absolute;
  //  padding: 8px;
  // left: 0;
  // top: 0;
  z-index: 1000;
  color: #FFFFFF;
}

.side-panel-body {
  display: none;
  flex-direction: column;
  width: 360px;
  background: #303A48;
  box-shadow: -2px 0px 4px rgba(0, 0, 0, 0.2);
}

.side-panel-body.active {
  display: flex;
}

.map {
  // position: absolute;
  // left: 0;
  // top: 0;
  background: gray;
  height: 100%;
  width: 100%;
}


.side-bar {
  width: 48px;
  background: linear-gradient(0deg, rgba(255, 255, 255, 0.14), rgba(255, 255, 255, 0.14)), #192433;
  border-right: #1E242D 1px solid;
  // border-radius: 4px 0 0 4px;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  box-sizing: border-box;
}

.side-bar .scene,
.side-bar .source,
.side-bar .console {
  margin: 8px;
}

$focusColor: #77F4E8;
$textColor: #FFFFFF;

.scene,
.source,
.console {
  height: 24px;
  padding: 4px;
}

.scene.active,
.source.active,
.console.active {
  box-shadow: inset 0 0 5px rgba(0, 0, 0, 0.121716);
  border-radius: 4px;
  background: #27303C;
}

.scene.active svg path,
.source.active svg path,
.console.active svg path {
  fill: $focusColor;
}

.side-panel-body header {
  display: flex;
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 18px;
  padding: 16px;
  /* border-bottom: #1E242D 1px solid; */
  box-sizing: border-box;
  flex-shrink: 0;

  span {
    flex-grow: 1;
  }

  .icon {
    cursor: pointer;
  }
}

.side-panel-body footer {
  flex-shrink: 0;
  background: red;
  height: 10px;
}

.properties-section {
  flex-shrink: 0;
  display: flex;
  max-height: 220px;
  flex-direction: column;
  overflow: auto;
  margin: 8px;
  box-sizing: border-box;
  background: #202A38;
  border-radius: 4px;
}

.properties {
  display: flex;
  flex-direction: column;
  padding: 8px;

  .property {
    display: flex;
    margin-bottom: 4px;

    .name {
      font-family: Courier, monospace;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 16px;
      color: rgba(207, 216, 221, 0.5);
    }

    .value {
      margin-left: 10px;
      font-family: Courier, monospace;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 16px;
      color: #FFFFFF;
    }
  }
}


.features-section {
  display: flex;
  flex-grow: 1;
  flex-direction: column;
  padding-top: 0;
  overflow: auto;
}

.feature {
  margin: 0;
  display: flex;
  padding: 6px 8px 6px 16px;
  color: #5F9BFA;
  cursor: pointer;
}

.feature.active {
  background: #3E4B5D;
  padding: 2px 2px 2px 10px;
  height: 28px;
  align-items: center;
  box-sizing: border-box;
}

.feature.active > * {
  margin-left: 6px;
  margin-right: 6px;
}

.feature-name {
  color: $textColor;
  flex-grow: 1;
  font-style: normal;
  font-weight: normal;
  font-size: 14px;
  line-height: 16px;
  max-height: 16px;
  height: 16px;
  margin-left: 8px;
  margin-right: 8px;
}

.feature-name-editor {
  cursor: pointer;
  flex-grow: 1;
  font-family: inherit;
  font-style: normal;
  font-weight: normal;
  font-size: 14px;
  line-height: 14;
  color: $textColor;
  border: 0;
  height: 24px;
  outline: none;
  caret-color: $focusColor;
  background: transparent;
  border-radius: 2px;
  box-sizing: border-box;
  padding-left: 6px;
  margin-left: -6px;
}

.feature-delete {
  cursor: pointer;
  width: 16px;
  height: 16px;
}

.feature.active > .feature-name-editor {
  margin-left: -4px;
  margin-right: 6px;
}

::selection {
  background-color: $focusColor;
  color: #fff;
}

.zoom-panel {
  position: absolute;
  width: 32px;
  height: 68px;
  right: 16px;
  top: calc(50% - 34px);
  background: rgba(25, 36, 51, 0.8);
  border-radius: 16px;
  z-index: 1000;
  display: flex;
  flex-direction: column;
  padding: 8px;
  justify-content: space-between;
  box-sizing: border-box;
  cursor: pointer;
}

.zoom-button {
  color: $textColor;
}


.zoom-separator {
  height: 1px;
  width: 16px;
  background: rgba(132, 149, 172, 0.4);
  border-radius: 20px;
}

.scale-panel {
  position: absolute;
  width: 70px;
  height: 20px;
  right: 8px;
  bottom: 8px;
  background: rgba(25, 36, 51, 0.8);
  border-radius: 2px;
  z-index: 1000;
}

.scale-value {
  position: absolute;
  left: 23px;
  right: 23px;
  top: 4px;
  bottom: 4px;
  font-style: normal;
  font-weight: bold;
  font-size: 10px;
  line-height: 12px;
  text-align: center;
  color: #FFFFFF;
}

.tools-bar {
  position: absolute;
  right: 0;
  display: flex;
  justify-content: flex-end;
  padding: 8px;
}

.tools-bar .colors-palette,
.tools-bar .tools-panel {
  margin: 8px;
}

.tools-panel {
  height: 40px;
  background: rgba(25, 36, 51, 0.8);
  border-radius: 4px;
  z-index: 1000;
  display: flex;
  padding: 4px;
  box-sizing: border-box;
  color: $textColor;
  cursor: pointer;
}

.tool {
  color: $textColor;
  fill: $textColor;
}

.tool.active {
  color: $focusColor;
  fill: $focusColor;
}

.tool-separator {
  background: rgba(132, 149, 172, 0.4);
  border-radius: 20px;
  height: 16px;
  width: 1px;
}

.tools-panel > .tool {
  padding: 4px;
}

.tools-panel > .tool-separator {
  margin: 8px 4px 4px;
}

.colors-palette {
  height: 40px;
  background: rgba(25, 36, 51, 0.8);
  border-radius: 4px;
  z-index: 1000;
  display: flex;
  align-items: center;
  padding: 4px;
  box-sizing: border-box;
  color: $textColor;
  cursor: pointer;
}

.colors-palette > .variant {
  padding: 4px;
}

.variant.facility {
  color: #5F9BFA;
}

.variant.restricted-area {
  color: #F15050;
}

.variant.area-a {
  color: #34AF7B;
}

.variant.area-b {
  color: #1E7D7F;
}

.variant.bounding-area {
  color: #8495AC;
}

.variant {
  display: block;
  position: relative;
  padding: 0;
  margin: 0;
  line-height: 16px;
  width: 32px;
  height: 32px;
  box-sizing: border-box;
}

.variant-icon {
  width: 12px;
  height: 12px;
  border-radius: 2px;
  background: red;
}

.variant-background {
  display: none;
}

.variant:hover .variant-background {
  background: yellow;
  position: absolute;
  z-index: -1;
  width: 12px;
  height: 12px;
  border-radius: 2px;
  left: 10px;
  top: 10px;
  box-shadow: 0 0 8px rgba(0, 0, 0, 0.5);
}


.variant-selection {
  color: $textColor;
  display: block;
  position: absolute;
  left: 8px;
  top: 8px;
  z-index: 1;
  fill: white;
}


.code-section {
  overflow: auto;
  padding: 8px;
  padding-top: 0;
}

textarea {
  caret-color: $focusColor;
}

.CodeMirror-cursor {
  background-color: $focusColor;
  width: 1px;
  border: none;
}

.CodeMirror {
  width: 100%;
  height: 100%;
  border-radius: 4px;
  color: $textColor;

  font-family: Courier, monospace;
  font-style: normal;
  font-weight: normal;
  font-size: 12px;
  line-height: 16px;
  background: #202A38;
  caret-color: $focusColor;
}

.CodeMirror-gutters {
  background: #202A38;
  border-right: 1px #2A3443 solid;
}

.CodeMirror-linenumber {
  background: #202A38;
  color: rgba(207, 216, 221, 0.5);
}

.cm-s-default .cm-string {
  color: #629DE2;
}


.cm-s-default .CodeMirror-focused {
  background: red;
}


.cm-s-default .cm-number {
  color: #77F4A2;
}

.CodeMirror-focused .CodeMirror-selected {
  background: #2F435F;
}

.CodeMirror-crosshair {
  cursor: crosshair;
}

.CodeMirror-selected {
  background: #2F435F;
}

.CodeMirror-line::selection, .CodeMirror-line > span::selection, .CodeMirror-line > span > span::selection {
  background: #2F435F;
}

.CodeMirror-line::-moz-selection, .CodeMirror-line > span::-moz-selection, .CodeMirror-line > span > span::-moz-selection {
  background: #2F435F;
}
